/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"time"
)

// checks if the Contact type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Contact{}

// Contact struct for Contact
type Contact struct {
	// Profile name. Contacts created automatically out of conversations have messenger profile name here
	Name string `json:"name"`
	// Contact timezone in IANA format
	Timezone *string `json:"timezone,omitempty"`
	// Mobile number in E.164 format
	Mobile *string `json:"mobile,omitempty"`
	// NOT EDITABLE VIA API  Flag to mark mobile number as verified
	MobileVerified *bool `json:"mobile_verified,omitempty"`
	FirstName *string `json:"first_name,omitempty"`
	LastName *string `json:"last_name,omitempty"`
	Email *string `json:"email,omitempty"`
	Gender *string `json:"gender,omitempty"`
	Title *string `json:"title,omitempty"`
	Formal *bool `json:"formal,omitempty"`
	// Birthdate in format specified in organization settings. Default is yyyy-mm-dd
	Birthdate *string `json:"birthdate,omitempty"`
	// Overriden with birthdate data if provided
	DayOfBirth *int32 `json:"day_of_birth,omitempty"`
	// Overriden with birthdate data if provided
	MonthOfBirth *int32 `json:"month_of_birth,omitempty"`
	Address *ContactAddress `json:"address,omitempty"`
	// NOT EDITABLE VIA API  Stores current loyalty points of a contact. Format [providerName_projectId]: [pointsAmount] }
	LoyaltyPoints *map[string]int32 `json:"loyalty_points,omitempty"`
	// NOT EDITABLE VIA API  Stores lifetime loyalty points of a contact. Format { [providerName_projectId]: [pointsAmount] }
	LifetimeLoyaltyPoints *map[string]int32 `json:"lifetime_loyalty_points,omitempty"`
	// JSON with custom properties as defined in organization settings. Format: { [propertyName]: { type: [string|float|bool|date|datetime], value: [propertyValue] } }
	StrictAttributes *map[string]ContactStrictAttribute `json:"strict_attributes,omitempty"`
	CareOf *string `json:"care_of,omitempty"`
	Avatars *ContactAvatars `json:"avatars,omitempty"`
	Languages *ContactLanguages `json:"languages,omitempty"`
	// NOT EDITABLE VIA API  Timestamp when mobile number was marked as verified
	MobileVerifiedAt *string `json:"mobile_verified_at,omitempty"`
	// NOT EDITABLE VIA API  JSON with external IDs. Format: { [system_name]: [user_id] }
	ExternalIds map[string]interface{} `json:"external_ids,omitempty"`
	ErConfidence *ContactERConfidence `json:"er_confidence,omitempty"`
	Id string `json:"id"`
	OrganizationId string `json:"organization_id"`
	// NOT EDITABLE VIA API
	Segments []Segment `json:"segments,omitempty"`
	// NOT EDITABLE VIA API  Based on contact chat activity. Contact is 'active' if his last message is not older than activity threshold configured in Organization
	Active bool `json:"active"`
	// NOT EDITABLE VIA API  Indicator whether contact is active or deleted
	Status string `json:"status"`
	// NOT EDITABLE VIA API  Timestamp of last contact activity, usually message sent to SLACE conversation
	LastActiveAt *time.Time `json:"last_active_at,omitempty"`
	// NOT EDITABLE VIA API
	ExternalLinks []ExternalSystemLink `json:"external_links,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
	// NOT EDITABLE VIA API
	ComChannels []CommunicationChannel `json:"com_channels,omitempty"`
	// NOT EDITABLE VIA API
	// Deprecated
	PlatformComChannels []PlatformCommunicationChannel `json:"platform_com_channels,omitempty"`
	// NOT EDITABLE VIA API
	Coupons []Coupon `json:"coupons,omitempty"`
	// NOT EDITABLE VIA API
	Devices []ContactDevices `json:"devices,omitempty"`
	MobileDevice *ContactDevices `json:"mobile_device,omitempty"`
	// NOT EDITABLE VIA API  Imported contacts contain reference to the import batch (unique ID of single import)
	ImportBatchId *string `json:"import_batch_id,omitempty"`
	// Age (in full years) based on birthdate
	Age *int32 `json:"age,omitempty"`
	GivenConsents *ContactAllOfGivenConsents `json:"given_consents,omitempty"`
	ConsentKeys []string `json:"consent_keys"`
}

// NewContact instantiates a new Contact object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContact(name string, id string, organizationId string, active bool, status string, createdAt time.Time, updatedAt time.Time, consentKeys []string) *Contact {
	this := Contact{}
	this.Name = name
	this.Id = id
	this.OrganizationId = organizationId
	this.Active = active
	this.Status = status
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	this.ConsentKeys = consentKeys
	return &this
}

// NewContactWithDefaults instantiates a new Contact object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactWithDefaults() *Contact {
	this := Contact{}
	return &this
}

// GetName returns the Name field value
func (o *Contact) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Contact) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Contact) SetName(v string) {
	o.Name = v
}

// GetTimezone returns the Timezone field value if set, zero value otherwise.
func (o *Contact) GetTimezone() string {
	if o == nil || IsNil(o.Timezone) {
		var ret string
		return ret
	}
	return *o.Timezone
}

// GetTimezoneOk returns a tuple with the Timezone field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetTimezoneOk() (*string, bool) {
	if o == nil || IsNil(o.Timezone) {
		return nil, false
	}
	return o.Timezone, true
}

// HasTimezone returns a boolean if a field has been set.
func (o *Contact) HasTimezone() bool {
	if o != nil && !IsNil(o.Timezone) {
		return true
	}

	return false
}

// SetTimezone gets a reference to the given string and assigns it to the Timezone field.
func (o *Contact) SetTimezone(v string) {
	o.Timezone = &v
}

// GetMobile returns the Mobile field value if set, zero value otherwise.
func (o *Contact) GetMobile() string {
	if o == nil || IsNil(o.Mobile) {
		var ret string
		return ret
	}
	return *o.Mobile
}

// GetMobileOk returns a tuple with the Mobile field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetMobileOk() (*string, bool) {
	if o == nil || IsNil(o.Mobile) {
		return nil, false
	}
	return o.Mobile, true
}

// HasMobile returns a boolean if a field has been set.
func (o *Contact) HasMobile() bool {
	if o != nil && !IsNil(o.Mobile) {
		return true
	}

	return false
}

// SetMobile gets a reference to the given string and assigns it to the Mobile field.
func (o *Contact) SetMobile(v string) {
	o.Mobile = &v
}

// GetMobileVerified returns the MobileVerified field value if set, zero value otherwise.
func (o *Contact) GetMobileVerified() bool {
	if o == nil || IsNil(o.MobileVerified) {
		var ret bool
		return ret
	}
	return *o.MobileVerified
}

// GetMobileVerifiedOk returns a tuple with the MobileVerified field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetMobileVerifiedOk() (*bool, bool) {
	if o == nil || IsNil(o.MobileVerified) {
		return nil, false
	}
	return o.MobileVerified, true
}

// HasMobileVerified returns a boolean if a field has been set.
func (o *Contact) HasMobileVerified() bool {
	if o != nil && !IsNil(o.MobileVerified) {
		return true
	}

	return false
}

// SetMobileVerified gets a reference to the given bool and assigns it to the MobileVerified field.
func (o *Contact) SetMobileVerified(v bool) {
	o.MobileVerified = &v
}

// GetFirstName returns the FirstName field value if set, zero value otherwise.
func (o *Contact) GetFirstName() string {
	if o == nil || IsNil(o.FirstName) {
		var ret string
		return ret
	}
	return *o.FirstName
}

// GetFirstNameOk returns a tuple with the FirstName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetFirstNameOk() (*string, bool) {
	if o == nil || IsNil(o.FirstName) {
		return nil, false
	}
	return o.FirstName, true
}

// HasFirstName returns a boolean if a field has been set.
func (o *Contact) HasFirstName() bool {
	if o != nil && !IsNil(o.FirstName) {
		return true
	}

	return false
}

// SetFirstName gets a reference to the given string and assigns it to the FirstName field.
func (o *Contact) SetFirstName(v string) {
	o.FirstName = &v
}

// GetLastName returns the LastName field value if set, zero value otherwise.
func (o *Contact) GetLastName() string {
	if o == nil || IsNil(o.LastName) {
		var ret string
		return ret
	}
	return *o.LastName
}

// GetLastNameOk returns a tuple with the LastName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetLastNameOk() (*string, bool) {
	if o == nil || IsNil(o.LastName) {
		return nil, false
	}
	return o.LastName, true
}

// HasLastName returns a boolean if a field has been set.
func (o *Contact) HasLastName() bool {
	if o != nil && !IsNil(o.LastName) {
		return true
	}

	return false
}

// SetLastName gets a reference to the given string and assigns it to the LastName field.
func (o *Contact) SetLastName(v string) {
	o.LastName = &v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *Contact) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *Contact) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *Contact) SetEmail(v string) {
	o.Email = &v
}

// GetGender returns the Gender field value if set, zero value otherwise.
func (o *Contact) GetGender() string {
	if o == nil || IsNil(o.Gender) {
		var ret string
		return ret
	}
	return *o.Gender
}

// GetGenderOk returns a tuple with the Gender field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetGenderOk() (*string, bool) {
	if o == nil || IsNil(o.Gender) {
		return nil, false
	}
	return o.Gender, true
}

// HasGender returns a boolean if a field has been set.
func (o *Contact) HasGender() bool {
	if o != nil && !IsNil(o.Gender) {
		return true
	}

	return false
}

// SetGender gets a reference to the given string and assigns it to the Gender field.
func (o *Contact) SetGender(v string) {
	o.Gender = &v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *Contact) GetTitle() string {
	if o == nil || IsNil(o.Title) {
		var ret string
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetTitleOk() (*string, bool) {
	if o == nil || IsNil(o.Title) {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *Contact) HasTitle() bool {
	if o != nil && !IsNil(o.Title) {
		return true
	}

	return false
}

// SetTitle gets a reference to the given string and assigns it to the Title field.
func (o *Contact) SetTitle(v string) {
	o.Title = &v
}

// GetFormal returns the Formal field value if set, zero value otherwise.
func (o *Contact) GetFormal() bool {
	if o == nil || IsNil(o.Formal) {
		var ret bool
		return ret
	}
	return *o.Formal
}

// GetFormalOk returns a tuple with the Formal field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetFormalOk() (*bool, bool) {
	if o == nil || IsNil(o.Formal) {
		return nil, false
	}
	return o.Formal, true
}

// HasFormal returns a boolean if a field has been set.
func (o *Contact) HasFormal() bool {
	if o != nil && !IsNil(o.Formal) {
		return true
	}

	return false
}

// SetFormal gets a reference to the given bool and assigns it to the Formal field.
func (o *Contact) SetFormal(v bool) {
	o.Formal = &v
}

// GetBirthdate returns the Birthdate field value if set, zero value otherwise.
func (o *Contact) GetBirthdate() string {
	if o == nil || IsNil(o.Birthdate) {
		var ret string
		return ret
	}
	return *o.Birthdate
}

// GetBirthdateOk returns a tuple with the Birthdate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetBirthdateOk() (*string, bool) {
	if o == nil || IsNil(o.Birthdate) {
		return nil, false
	}
	return o.Birthdate, true
}

// HasBirthdate returns a boolean if a field has been set.
func (o *Contact) HasBirthdate() bool {
	if o != nil && !IsNil(o.Birthdate) {
		return true
	}

	return false
}

// SetBirthdate gets a reference to the given string and assigns it to the Birthdate field.
func (o *Contact) SetBirthdate(v string) {
	o.Birthdate = &v
}

// GetDayOfBirth returns the DayOfBirth field value if set, zero value otherwise.
func (o *Contact) GetDayOfBirth() int32 {
	if o == nil || IsNil(o.DayOfBirth) {
		var ret int32
		return ret
	}
	return *o.DayOfBirth
}

// GetDayOfBirthOk returns a tuple with the DayOfBirth field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetDayOfBirthOk() (*int32, bool) {
	if o == nil || IsNil(o.DayOfBirth) {
		return nil, false
	}
	return o.DayOfBirth, true
}

// HasDayOfBirth returns a boolean if a field has been set.
func (o *Contact) HasDayOfBirth() bool {
	if o != nil && !IsNil(o.DayOfBirth) {
		return true
	}

	return false
}

// SetDayOfBirth gets a reference to the given int32 and assigns it to the DayOfBirth field.
func (o *Contact) SetDayOfBirth(v int32) {
	o.DayOfBirth = &v
}

// GetMonthOfBirth returns the MonthOfBirth field value if set, zero value otherwise.
func (o *Contact) GetMonthOfBirth() int32 {
	if o == nil || IsNil(o.MonthOfBirth) {
		var ret int32
		return ret
	}
	return *o.MonthOfBirth
}

// GetMonthOfBirthOk returns a tuple with the MonthOfBirth field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetMonthOfBirthOk() (*int32, bool) {
	if o == nil || IsNil(o.MonthOfBirth) {
		return nil, false
	}
	return o.MonthOfBirth, true
}

// HasMonthOfBirth returns a boolean if a field has been set.
func (o *Contact) HasMonthOfBirth() bool {
	if o != nil && !IsNil(o.MonthOfBirth) {
		return true
	}

	return false
}

// SetMonthOfBirth gets a reference to the given int32 and assigns it to the MonthOfBirth field.
func (o *Contact) SetMonthOfBirth(v int32) {
	o.MonthOfBirth = &v
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *Contact) GetAddress() ContactAddress {
	if o == nil || IsNil(o.Address) {
		var ret ContactAddress
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetAddressOk() (*ContactAddress, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *Contact) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given ContactAddress and assigns it to the Address field.
func (o *Contact) SetAddress(v ContactAddress) {
	o.Address = &v
}

// GetLoyaltyPoints returns the LoyaltyPoints field value if set, zero value otherwise.
func (o *Contact) GetLoyaltyPoints() map[string]int32 {
	if o == nil || IsNil(o.LoyaltyPoints) {
		var ret map[string]int32
		return ret
	}
	return *o.LoyaltyPoints
}

// GetLoyaltyPointsOk returns a tuple with the LoyaltyPoints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetLoyaltyPointsOk() (*map[string]int32, bool) {
	if o == nil || IsNil(o.LoyaltyPoints) {
		return nil, false
	}
	return o.LoyaltyPoints, true
}

// HasLoyaltyPoints returns a boolean if a field has been set.
func (o *Contact) HasLoyaltyPoints() bool {
	if o != nil && !IsNil(o.LoyaltyPoints) {
		return true
	}

	return false
}

// SetLoyaltyPoints gets a reference to the given map[string]int32 and assigns it to the LoyaltyPoints field.
func (o *Contact) SetLoyaltyPoints(v map[string]int32) {
	o.LoyaltyPoints = &v
}

// GetLifetimeLoyaltyPoints returns the LifetimeLoyaltyPoints field value if set, zero value otherwise.
func (o *Contact) GetLifetimeLoyaltyPoints() map[string]int32 {
	if o == nil || IsNil(o.LifetimeLoyaltyPoints) {
		var ret map[string]int32
		return ret
	}
	return *o.LifetimeLoyaltyPoints
}

// GetLifetimeLoyaltyPointsOk returns a tuple with the LifetimeLoyaltyPoints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetLifetimeLoyaltyPointsOk() (*map[string]int32, bool) {
	if o == nil || IsNil(o.LifetimeLoyaltyPoints) {
		return nil, false
	}
	return o.LifetimeLoyaltyPoints, true
}

// HasLifetimeLoyaltyPoints returns a boolean if a field has been set.
func (o *Contact) HasLifetimeLoyaltyPoints() bool {
	if o != nil && !IsNil(o.LifetimeLoyaltyPoints) {
		return true
	}

	return false
}

// SetLifetimeLoyaltyPoints gets a reference to the given map[string]int32 and assigns it to the LifetimeLoyaltyPoints field.
func (o *Contact) SetLifetimeLoyaltyPoints(v map[string]int32) {
	o.LifetimeLoyaltyPoints = &v
}

// GetStrictAttributes returns the StrictAttributes field value if set, zero value otherwise.
func (o *Contact) GetStrictAttributes() map[string]ContactStrictAttribute {
	if o == nil || IsNil(o.StrictAttributes) {
		var ret map[string]ContactStrictAttribute
		return ret
	}
	return *o.StrictAttributes
}

// GetStrictAttributesOk returns a tuple with the StrictAttributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetStrictAttributesOk() (*map[string]ContactStrictAttribute, bool) {
	if o == nil || IsNil(o.StrictAttributes) {
		return nil, false
	}
	return o.StrictAttributes, true
}

// HasStrictAttributes returns a boolean if a field has been set.
func (o *Contact) HasStrictAttributes() bool {
	if o != nil && !IsNil(o.StrictAttributes) {
		return true
	}

	return false
}

// SetStrictAttributes gets a reference to the given map[string]ContactStrictAttribute and assigns it to the StrictAttributes field.
func (o *Contact) SetStrictAttributes(v map[string]ContactStrictAttribute) {
	o.StrictAttributes = &v
}

// GetCareOf returns the CareOf field value if set, zero value otherwise.
func (o *Contact) GetCareOf() string {
	if o == nil || IsNil(o.CareOf) {
		var ret string
		return ret
	}
	return *o.CareOf
}

// GetCareOfOk returns a tuple with the CareOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetCareOfOk() (*string, bool) {
	if o == nil || IsNil(o.CareOf) {
		return nil, false
	}
	return o.CareOf, true
}

// HasCareOf returns a boolean if a field has been set.
func (o *Contact) HasCareOf() bool {
	if o != nil && !IsNil(o.CareOf) {
		return true
	}

	return false
}

// SetCareOf gets a reference to the given string and assigns it to the CareOf field.
func (o *Contact) SetCareOf(v string) {
	o.CareOf = &v
}

// GetAvatars returns the Avatars field value if set, zero value otherwise.
func (o *Contact) GetAvatars() ContactAvatars {
	if o == nil || IsNil(o.Avatars) {
		var ret ContactAvatars
		return ret
	}
	return *o.Avatars
}

// GetAvatarsOk returns a tuple with the Avatars field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetAvatarsOk() (*ContactAvatars, bool) {
	if o == nil || IsNil(o.Avatars) {
		return nil, false
	}
	return o.Avatars, true
}

// HasAvatars returns a boolean if a field has been set.
func (o *Contact) HasAvatars() bool {
	if o != nil && !IsNil(o.Avatars) {
		return true
	}

	return false
}

// SetAvatars gets a reference to the given ContactAvatars and assigns it to the Avatars field.
func (o *Contact) SetAvatars(v ContactAvatars) {
	o.Avatars = &v
}

// GetLanguages returns the Languages field value if set, zero value otherwise.
func (o *Contact) GetLanguages() ContactLanguages {
	if o == nil || IsNil(o.Languages) {
		var ret ContactLanguages
		return ret
	}
	return *o.Languages
}

// GetLanguagesOk returns a tuple with the Languages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetLanguagesOk() (*ContactLanguages, bool) {
	if o == nil || IsNil(o.Languages) {
		return nil, false
	}
	return o.Languages, true
}

// HasLanguages returns a boolean if a field has been set.
func (o *Contact) HasLanguages() bool {
	if o != nil && !IsNil(o.Languages) {
		return true
	}

	return false
}

// SetLanguages gets a reference to the given ContactLanguages and assigns it to the Languages field.
func (o *Contact) SetLanguages(v ContactLanguages) {
	o.Languages = &v
}

// GetMobileVerifiedAt returns the MobileVerifiedAt field value if set, zero value otherwise.
func (o *Contact) GetMobileVerifiedAt() string {
	if o == nil || IsNil(o.MobileVerifiedAt) {
		var ret string
		return ret
	}
	return *o.MobileVerifiedAt
}

// GetMobileVerifiedAtOk returns a tuple with the MobileVerifiedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetMobileVerifiedAtOk() (*string, bool) {
	if o == nil || IsNil(o.MobileVerifiedAt) {
		return nil, false
	}
	return o.MobileVerifiedAt, true
}

// HasMobileVerifiedAt returns a boolean if a field has been set.
func (o *Contact) HasMobileVerifiedAt() bool {
	if o != nil && !IsNil(o.MobileVerifiedAt) {
		return true
	}

	return false
}

// SetMobileVerifiedAt gets a reference to the given string and assigns it to the MobileVerifiedAt field.
func (o *Contact) SetMobileVerifiedAt(v string) {
	o.MobileVerifiedAt = &v
}

// GetExternalIds returns the ExternalIds field value if set, zero value otherwise.
func (o *Contact) GetExternalIds() map[string]interface{} {
	if o == nil || IsNil(o.ExternalIds) {
		var ret map[string]interface{}
		return ret
	}
	return o.ExternalIds
}

// GetExternalIdsOk returns a tuple with the ExternalIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetExternalIdsOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.ExternalIds) {
		return map[string]interface{}{}, false
	}
	return o.ExternalIds, true
}

// HasExternalIds returns a boolean if a field has been set.
func (o *Contact) HasExternalIds() bool {
	if o != nil && !IsNil(o.ExternalIds) {
		return true
	}

	return false
}

// SetExternalIds gets a reference to the given map[string]interface{} and assigns it to the ExternalIds field.
func (o *Contact) SetExternalIds(v map[string]interface{}) {
	o.ExternalIds = v
}

// GetErConfidence returns the ErConfidence field value if set, zero value otherwise.
func (o *Contact) GetErConfidence() ContactERConfidence {
	if o == nil || IsNil(o.ErConfidence) {
		var ret ContactERConfidence
		return ret
	}
	return *o.ErConfidence
}

// GetErConfidenceOk returns a tuple with the ErConfidence field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetErConfidenceOk() (*ContactERConfidence, bool) {
	if o == nil || IsNil(o.ErConfidence) {
		return nil, false
	}
	return o.ErConfidence, true
}

// HasErConfidence returns a boolean if a field has been set.
func (o *Contact) HasErConfidence() bool {
	if o != nil && !IsNil(o.ErConfidence) {
		return true
	}

	return false
}

// SetErConfidence gets a reference to the given ContactERConfidence and assigns it to the ErConfidence field.
func (o *Contact) SetErConfidence(v ContactERConfidence) {
	o.ErConfidence = &v
}

// GetId returns the Id field value
func (o *Contact) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Contact) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Contact) SetId(v string) {
	o.Id = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *Contact) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *Contact) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *Contact) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetSegments returns the Segments field value if set, zero value otherwise.
func (o *Contact) GetSegments() []Segment {
	if o == nil || IsNil(o.Segments) {
		var ret []Segment
		return ret
	}
	return o.Segments
}

// GetSegmentsOk returns a tuple with the Segments field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetSegmentsOk() ([]Segment, bool) {
	if o == nil || IsNil(o.Segments) {
		return nil, false
	}
	return o.Segments, true
}

// HasSegments returns a boolean if a field has been set.
func (o *Contact) HasSegments() bool {
	if o != nil && !IsNil(o.Segments) {
		return true
	}

	return false
}

// SetSegments gets a reference to the given []Segment and assigns it to the Segments field.
func (o *Contact) SetSegments(v []Segment) {
	o.Segments = v
}

// GetActive returns the Active field value
func (o *Contact) GetActive() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Active
}

// GetActiveOk returns a tuple with the Active field value
// and a boolean to check if the value has been set.
func (o *Contact) GetActiveOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Active, true
}

// SetActive sets field value
func (o *Contact) SetActive(v bool) {
	o.Active = v
}

// GetStatus returns the Status field value
func (o *Contact) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *Contact) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *Contact) SetStatus(v string) {
	o.Status = v
}

// GetLastActiveAt returns the LastActiveAt field value if set, zero value otherwise.
func (o *Contact) GetLastActiveAt() time.Time {
	if o == nil || IsNil(o.LastActiveAt) {
		var ret time.Time
		return ret
	}
	return *o.LastActiveAt
}

// GetLastActiveAtOk returns a tuple with the LastActiveAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetLastActiveAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LastActiveAt) {
		return nil, false
	}
	return o.LastActiveAt, true
}

// HasLastActiveAt returns a boolean if a field has been set.
func (o *Contact) HasLastActiveAt() bool {
	if o != nil && !IsNil(o.LastActiveAt) {
		return true
	}

	return false
}

// SetLastActiveAt gets a reference to the given time.Time and assigns it to the LastActiveAt field.
func (o *Contact) SetLastActiveAt(v time.Time) {
	o.LastActiveAt = &v
}

// GetExternalLinks returns the ExternalLinks field value if set, zero value otherwise.
func (o *Contact) GetExternalLinks() []ExternalSystemLink {
	if o == nil || IsNil(o.ExternalLinks) {
		var ret []ExternalSystemLink
		return ret
	}
	return o.ExternalLinks
}

// GetExternalLinksOk returns a tuple with the ExternalLinks field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetExternalLinksOk() ([]ExternalSystemLink, bool) {
	if o == nil || IsNil(o.ExternalLinks) {
		return nil, false
	}
	return o.ExternalLinks, true
}

// HasExternalLinks returns a boolean if a field has been set.
func (o *Contact) HasExternalLinks() bool {
	if o != nil && !IsNil(o.ExternalLinks) {
		return true
	}

	return false
}

// SetExternalLinks gets a reference to the given []ExternalSystemLink and assigns it to the ExternalLinks field.
func (o *Contact) SetExternalLinks(v []ExternalSystemLink) {
	o.ExternalLinks = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Contact) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Contact) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Contact) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *Contact) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *Contact) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *Contact) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

// GetComChannels returns the ComChannels field value if set, zero value otherwise.
func (o *Contact) GetComChannels() []CommunicationChannel {
	if o == nil || IsNil(o.ComChannels) {
		var ret []CommunicationChannel
		return ret
	}
	return o.ComChannels
}

// GetComChannelsOk returns a tuple with the ComChannels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetComChannelsOk() ([]CommunicationChannel, bool) {
	if o == nil || IsNil(o.ComChannels) {
		return nil, false
	}
	return o.ComChannels, true
}

// HasComChannels returns a boolean if a field has been set.
func (o *Contact) HasComChannels() bool {
	if o != nil && !IsNil(o.ComChannels) {
		return true
	}

	return false
}

// SetComChannels gets a reference to the given []CommunicationChannel and assigns it to the ComChannels field.
func (o *Contact) SetComChannels(v []CommunicationChannel) {
	o.ComChannels = v
}

// GetPlatformComChannels returns the PlatformComChannels field value if set, zero value otherwise.
// Deprecated
func (o *Contact) GetPlatformComChannels() []PlatformCommunicationChannel {
	if o == nil || IsNil(o.PlatformComChannels) {
		var ret []PlatformCommunicationChannel
		return ret
	}
	return o.PlatformComChannels
}

// GetPlatformComChannelsOk returns a tuple with the PlatformComChannels field value if set, nil otherwise
// and a boolean to check if the value has been set.
// Deprecated
func (o *Contact) GetPlatformComChannelsOk() ([]PlatformCommunicationChannel, bool) {
	if o == nil || IsNil(o.PlatformComChannels) {
		return nil, false
	}
	return o.PlatformComChannels, true
}

// HasPlatformComChannels returns a boolean if a field has been set.
func (o *Contact) HasPlatformComChannels() bool {
	if o != nil && !IsNil(o.PlatformComChannels) {
		return true
	}

	return false
}

// SetPlatformComChannels gets a reference to the given []PlatformCommunicationChannel and assigns it to the PlatformComChannels field.
// Deprecated
func (o *Contact) SetPlatformComChannels(v []PlatformCommunicationChannel) {
	o.PlatformComChannels = v
}

// GetCoupons returns the Coupons field value if set, zero value otherwise.
func (o *Contact) GetCoupons() []Coupon {
	if o == nil || IsNil(o.Coupons) {
		var ret []Coupon
		return ret
	}
	return o.Coupons
}

// GetCouponsOk returns a tuple with the Coupons field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetCouponsOk() ([]Coupon, bool) {
	if o == nil || IsNil(o.Coupons) {
		return nil, false
	}
	return o.Coupons, true
}

// HasCoupons returns a boolean if a field has been set.
func (o *Contact) HasCoupons() bool {
	if o != nil && !IsNil(o.Coupons) {
		return true
	}

	return false
}

// SetCoupons gets a reference to the given []Coupon and assigns it to the Coupons field.
func (o *Contact) SetCoupons(v []Coupon) {
	o.Coupons = v
}

// GetDevices returns the Devices field value if set, zero value otherwise.
func (o *Contact) GetDevices() []ContactDevices {
	if o == nil || IsNil(o.Devices) {
		var ret []ContactDevices
		return ret
	}
	return o.Devices
}

// GetDevicesOk returns a tuple with the Devices field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetDevicesOk() ([]ContactDevices, bool) {
	if o == nil || IsNil(o.Devices) {
		return nil, false
	}
	return o.Devices, true
}

// HasDevices returns a boolean if a field has been set.
func (o *Contact) HasDevices() bool {
	if o != nil && !IsNil(o.Devices) {
		return true
	}

	return false
}

// SetDevices gets a reference to the given []ContactDevices and assigns it to the Devices field.
func (o *Contact) SetDevices(v []ContactDevices) {
	o.Devices = v
}

// GetMobileDevice returns the MobileDevice field value if set, zero value otherwise.
func (o *Contact) GetMobileDevice() ContactDevices {
	if o == nil || IsNil(o.MobileDevice) {
		var ret ContactDevices
		return ret
	}
	return *o.MobileDevice
}

// GetMobileDeviceOk returns a tuple with the MobileDevice field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetMobileDeviceOk() (*ContactDevices, bool) {
	if o == nil || IsNil(o.MobileDevice) {
		return nil, false
	}
	return o.MobileDevice, true
}

// HasMobileDevice returns a boolean if a field has been set.
func (o *Contact) HasMobileDevice() bool {
	if o != nil && !IsNil(o.MobileDevice) {
		return true
	}

	return false
}

// SetMobileDevice gets a reference to the given ContactDevices and assigns it to the MobileDevice field.
func (o *Contact) SetMobileDevice(v ContactDevices) {
	o.MobileDevice = &v
}

// GetImportBatchId returns the ImportBatchId field value if set, zero value otherwise.
func (o *Contact) GetImportBatchId() string {
	if o == nil || IsNil(o.ImportBatchId) {
		var ret string
		return ret
	}
	return *o.ImportBatchId
}

// GetImportBatchIdOk returns a tuple with the ImportBatchId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetImportBatchIdOk() (*string, bool) {
	if o == nil || IsNil(o.ImportBatchId) {
		return nil, false
	}
	return o.ImportBatchId, true
}

// HasImportBatchId returns a boolean if a field has been set.
func (o *Contact) HasImportBatchId() bool {
	if o != nil && !IsNil(o.ImportBatchId) {
		return true
	}

	return false
}

// SetImportBatchId gets a reference to the given string and assigns it to the ImportBatchId field.
func (o *Contact) SetImportBatchId(v string) {
	o.ImportBatchId = &v
}

// GetAge returns the Age field value if set, zero value otherwise.
func (o *Contact) GetAge() int32 {
	if o == nil || IsNil(o.Age) {
		var ret int32
		return ret
	}
	return *o.Age
}

// GetAgeOk returns a tuple with the Age field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetAgeOk() (*int32, bool) {
	if o == nil || IsNil(o.Age) {
		return nil, false
	}
	return o.Age, true
}

// HasAge returns a boolean if a field has been set.
func (o *Contact) HasAge() bool {
	if o != nil && !IsNil(o.Age) {
		return true
	}

	return false
}

// SetAge gets a reference to the given int32 and assigns it to the Age field.
func (o *Contact) SetAge(v int32) {
	o.Age = &v
}

// GetGivenConsents returns the GivenConsents field value if set, zero value otherwise.
func (o *Contact) GetGivenConsents() ContactAllOfGivenConsents {
	if o == nil || IsNil(o.GivenConsents) {
		var ret ContactAllOfGivenConsents
		return ret
	}
	return *o.GivenConsents
}

// GetGivenConsentsOk returns a tuple with the GivenConsents field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Contact) GetGivenConsentsOk() (*ContactAllOfGivenConsents, bool) {
	if o == nil || IsNil(o.GivenConsents) {
		return nil, false
	}
	return o.GivenConsents, true
}

// HasGivenConsents returns a boolean if a field has been set.
func (o *Contact) HasGivenConsents() bool {
	if o != nil && !IsNil(o.GivenConsents) {
		return true
	}

	return false
}

// SetGivenConsents gets a reference to the given ContactAllOfGivenConsents and assigns it to the GivenConsents field.
func (o *Contact) SetGivenConsents(v ContactAllOfGivenConsents) {
	o.GivenConsents = &v
}

// GetConsentKeys returns the ConsentKeys field value
func (o *Contact) GetConsentKeys() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.ConsentKeys
}

// GetConsentKeysOk returns a tuple with the ConsentKeys field value
// and a boolean to check if the value has been set.
func (o *Contact) GetConsentKeysOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ConsentKeys, true
}

// SetConsentKeys sets field value
func (o *Contact) SetConsentKeys(v []string) {
	o.ConsentKeys = v
}

func (o Contact) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Contact) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	if !IsNil(o.Timezone) {
		toSerialize["timezone"] = o.Timezone
	}
	if !IsNil(o.Mobile) {
		toSerialize["mobile"] = o.Mobile
	}
	if !IsNil(o.MobileVerified) {
		toSerialize["mobile_verified"] = o.MobileVerified
	}
	if !IsNil(o.FirstName) {
		toSerialize["first_name"] = o.FirstName
	}
	if !IsNil(o.LastName) {
		toSerialize["last_name"] = o.LastName
	}
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	if !IsNil(o.Gender) {
		toSerialize["gender"] = o.Gender
	}
	if !IsNil(o.Title) {
		toSerialize["title"] = o.Title
	}
	if !IsNil(o.Formal) {
		toSerialize["formal"] = o.Formal
	}
	if !IsNil(o.Birthdate) {
		toSerialize["birthdate"] = o.Birthdate
	}
	if !IsNil(o.DayOfBirth) {
		toSerialize["day_of_birth"] = o.DayOfBirth
	}
	if !IsNil(o.MonthOfBirth) {
		toSerialize["month_of_birth"] = o.MonthOfBirth
	}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	if !IsNil(o.LoyaltyPoints) {
		toSerialize["loyalty_points"] = o.LoyaltyPoints
	}
	if !IsNil(o.LifetimeLoyaltyPoints) {
		toSerialize["lifetime_loyalty_points"] = o.LifetimeLoyaltyPoints
	}
	if !IsNil(o.StrictAttributes) {
		toSerialize["strict_attributes"] = o.StrictAttributes
	}
	if !IsNil(o.CareOf) {
		toSerialize["care_of"] = o.CareOf
	}
	if !IsNil(o.Avatars) {
		toSerialize["avatars"] = o.Avatars
	}
	if !IsNil(o.Languages) {
		toSerialize["languages"] = o.Languages
	}
	if !IsNil(o.MobileVerifiedAt) {
		toSerialize["mobile_verified_at"] = o.MobileVerifiedAt
	}
	if !IsNil(o.ExternalIds) {
		toSerialize["external_ids"] = o.ExternalIds
	}
	if !IsNil(o.ErConfidence) {
		toSerialize["er_confidence"] = o.ErConfidence
	}
	toSerialize["id"] = o.Id
	toSerialize["organization_id"] = o.OrganizationId
	if !IsNil(o.Segments) {
		toSerialize["segments"] = o.Segments
	}
	toSerialize["active"] = o.Active
	toSerialize["status"] = o.Status
	if !IsNil(o.LastActiveAt) {
		toSerialize["last_active_at"] = o.LastActiveAt
	}
	if !IsNil(o.ExternalLinks) {
		toSerialize["external_links"] = o.ExternalLinks
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	if !IsNil(o.ComChannels) {
		toSerialize["com_channels"] = o.ComChannels
	}
	if !IsNil(o.PlatformComChannels) {
		toSerialize["platform_com_channels"] = o.PlatformComChannels
	}
	if !IsNil(o.Coupons) {
		toSerialize["coupons"] = o.Coupons
	}
	if !IsNil(o.Devices) {
		toSerialize["devices"] = o.Devices
	}
	if !IsNil(o.MobileDevice) {
		toSerialize["mobile_device"] = o.MobileDevice
	}
	if !IsNil(o.ImportBatchId) {
		toSerialize["import_batch_id"] = o.ImportBatchId
	}
	if !IsNil(o.Age) {
		toSerialize["age"] = o.Age
	}
	if !IsNil(o.GivenConsents) {
		toSerialize["given_consents"] = o.GivenConsents
	}
	toSerialize["consent_keys"] = o.ConsentKeys
	return toSerialize, nil
}

type NullableContact struct {
	value *Contact
	isSet bool
}

func (v NullableContact) Get() *Contact {
	return v.value
}

func (v *NullableContact) Set(val *Contact) {
	v.value = val
	v.isSet = true
}

func (v NullableContact) IsSet() bool {
	return v.isSet
}

func (v *NullableContact) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContact(val *Contact) *NullableContact {
	return &NullableContact{value: val, isSet: true}
}

func (v NullableContact) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContact) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


